VERSION 5.00
Begin VB.UserControl uMultiMemo 
   ClientHeight    =   3315
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4920
   KeyPreview      =   -1  'True
   ScaleHeight     =   3315
   ScaleWidth      =   4920
   Begin VB.PictureBox picCounter 
      Height          =   300
      Left            =   4020
      ScaleHeight     =   240
      ScaleWidth      =   675
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   2880
      Width           =   735
      Begin VB.Label lblCounter 
         Alignment       =   1  'E
         Caption         =   "0/0"
         Height          =   165
         Left            =   0
         TabIndex        =   2
         Top             =   30
         Width           =   660
      End
   End
   Begin VB.ComboBox cmbMemoList 
      Height          =   300
      Left            =   1080
      TabIndex        =   1
      TabStop         =   0   'False
      Text            =   "cmbMemoList"
      Top             =   2880
      Width           =   2925
   End
   Begin VB.TextBox txtMemo 
      Height          =   2775
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  '
      TabIndex        =   4
      Top             =   60
      Width           =   4725
   End
   Begin VB.PictureBox picBar 
      BorderStyle     =   0  'Ȃ
      Height          =   315
      Left            =   0
      ScaleHeight     =   315
      ScaleWidth      =   1065
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   2820
      Width           =   1065
      Begin MomoMemo.uHoverButton cmdNew 
         Height          =   315
         Left            =   0
         Top             =   0
         Width           =   315
         _ExtentX        =   556
         _ExtentY        =   556
         Caption         =   ""
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "lr oSVbN"
            Size            =   9
            Charset         =   128
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Picture         =   "uMultiMemo.ctx":0000
      End
      Begin MomoMemo.uHoverButton cmdDelete 
         Height          =   315
         Left            =   315
         Top             =   0
         Width           =   315
         _ExtentX        =   556
         _ExtentY        =   556
         Caption         =   ""
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "lr oSVbN"
            Size            =   9
            Charset         =   128
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Picture         =   "uMultiMemo.ctx":0112
      End
      Begin MomoMemo.uHoverButton cmdPrev 
         Height          =   150
         Left            =   630
         Top             =   15
         Width           =   315
         _ExtentX        =   556
         _ExtentY        =   265
         Caption         =   "5"
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "Marlett"
            Size            =   9
            Charset         =   2
            Weight          =   500
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
      End
      Begin MomoMemo.uHoverButton cmdNext 
         Height          =   150
         Left            =   630
         Top             =   165
         Width           =   315
         _ExtentX        =   556
         _ExtentY        =   265
         Caption         =   "6"
         BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
            Name            =   "Marlett"
            Size            =   9
            Charset         =   2
            Weight          =   500
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
      End
   End
End
Attribute VB_Name = "uMultiMemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit


'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'--------------------------------------------------------------
Private Const CB_SHOWDROPDOWN = &H14F
Private Const CB_GETDROPPEDSTATE = &H157
'**************************************************************


'********************************************************************************
'* ϐ`
'********************************************************************************
Private m_FileName As String
Private m_HeaderFormat As String
Private m_BodyFormat As String
Private m_DateFormat As String
Private m_HeaderAddPosition As EnumAddPosition
Private m_BodyAddPosition As EnumAddPosition

Private mMemoList() As typeMemo     'Index=0̓_~[
Private m_MemoIndex As Long

Private m_IsChangedMemoTitle As Boolean


'********************************************************************************
'* 萔E^`
'********************************************************************************
Private Const mc_SECTION_SEPARATOR As String = vbCrLf & "." & vbCrLf

Public Enum EnumAddPosition
    apHead
    apTail
End Enum

Private Const mc_DEFAULT_HEADERFORMAT As String = "$DATE YourName <your@address>\n"
Private Const mc_DEFAULT_BODYFORMAT As String = "\t* $MEMO$CURSOR\n"
Private Const mc_DEFAULT_DATEFORMAT As String = "yyyy-mm-dd"
Private Const mc_DEFAULT_HEADERADDPOSITION As Long = apHead
Private Const mc_DEFAULT_BODYADDPOSITION As Long = apTail

Private Type typeMemo
    Title As String
    LastModified As String
    Body As String
    CursorPos As Long
End Type



'********************************************************************************
'* Cxg`
'********************************************************************************
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_UserMemId = -602
Public Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_UserMemId = -603
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_UserMemId = -604
Public Event BeforeDelete(MemoIndex As Long, Cancel As Boolean)
Public Event AfterExecuteFile()



'********************************************************************************
'* vpeB`
'********************************************************************************
Public Property Get FileName() As String
    FileName = m_FileName
End Property
Public Property Let FileName(ByVal NewFileName As String)
    If CheckFileName(NewFileName) Then
        m_FileName = NewFileName
    Else
        Call Err.Raise(53)
    End If
End Property

Public Property Get HeaderFormat() As String
    HeaderFormat = m_HeaderFormat
End Property
Public Property Let HeaderFormat(ByVal NewHeaderFormat As String)
    m_HeaderFormat = NewHeaderFormat
End Property

Public Property Get BodyFormat() As String
    BodyFormat = m_BodyFormat
End Property
Public Property Let BodyFormat(ByVal NewBodyFormat As String)
    m_BodyFormat = NewBodyFormat
End Property

Public Property Get DateFormat() As String
    DateFormat = m_DateFormat
End Property
Public Property Let DateFormat(ByVal NewDateFormat As String)
    m_DateFormat = NewDateFormat
End Property

Public Property Get HeaderAddPosition() As EnumAddPosition
    HeaderAddPosition = m_HeaderAddPosition
End Property
Public Property Let HeaderAddPosition(ByVal NewHeaderAddPosition As EnumAddPosition)
    m_HeaderAddPosition = NewHeaderAddPosition
End Property

Public Property Get BodyAddPosition() As EnumAddPosition
    BodyAddPosition = m_BodyAddPosition
End Property
Public Property Let BodyAddPosition(ByVal NewBodyAddPosition As EnumAddPosition)
    m_BodyAddPosition = NewBodyAddPosition
End Property

Public Property Get MemoCount() As Long
    MemoCount = UBound(mMemoList)
End Property

Public Property Get MemoIndex() As Long
    MemoIndex = m_MemoIndex
End Property
Public Property Let MemoIndex(ByVal NewMemoIndex As Long)
    'CfbNX␳
    If Me.MemoCount = 0 Then
        NewMemoIndex = 0
    ElseIf NewMemoIndex < 1 Then
        NewMemoIndex = 1
    ElseIf NewMemoIndex > Me.MemoCount Then
        NewMemoIndex = Me.MemoCount
    End If

    If NewMemoIndex <> m_MemoIndex Then
        '܂ł̃̓eۑ
        If m_MemoIndex > 0 Then
            mMemoList(m_MemoIndex) = GetDisplayMemo()
        End If
    
        'Iꂽ\
        m_MemoIndex = NewMemoIndex
        Call ShowMemo(m_MemoIndex)
    End If
End Property



'********************************************************************************
'* \bh`
'********************************************************************************
'**
' Ɉsǉ
' @param Message ǉ郁bZ[W
' @param MemoIndex ǉ郁ԍ
Public Sub AddMessage(ByVal Message As String _
                    , Optional ByVal MemoIndex As Long = -1)
    'ԍ̎w肪ȂƂ͍̃B
    If MemoIndex < 0 Then
        MemoIndex = m_MemoIndex
    End If
    
    'ǉ
    Dim LastModified As String
    LastModified = Format$(Now(), Me.DateFormat)
'''    If mMemoList(MemoIndex).LastModified = LastModified Then
'''        Call AddMemo_Body(mMemoList(MemoIndex), Message, LastModified)
'''    Else
'''        Call AddMemo_Header(mMemoList(MemoIndex), Message, LastModified)
'''    End If
    With mMemoList(MemoIndex)
        .Body = .Body _
              & "[" & Format$(Now(), "yyyy/mm/dd hh:mm:ss") & "] " & Message & vbCrLf
        .CursorPos = Len(.Body)
        .LastModified = LastModified
    End With

    'ANeBuȃǉ̂ɕύX
    Call ShowMemo(MemoIndex)
    
End Sub

'**
' t@CǂݍŃ\B
Public Sub Load()
    'f[^t@Cǂݍ
    Call LoadFile
    
    '̏ꍇ͈ꌏVKɍ쐬
    If Me.MemoCount = 0 Then
        Call CreateNewMemo
    End If
    
    '^Cgꗗ쐬
    Dim i As Long
    Call cmbMemoList.Clear
    For i = 1 To Me.MemoCount
        Call cmbMemoList.AddItem(mMemoList(i).Title)
    Next i

    'IĂȂΈꌏڂI
    Dim prevMemoIndex As Long
    prevMemoIndex = m_MemoIndex
    If m_MemoIndex < 0 Then
        prevMemoIndex = 1
    End If
    m_MemoIndex = -1
    Me.MemoIndex = prevMemoIndex
End Sub

'**
' ̏Ԃt@CɕۑB
Public Sub Save()
    '܂ł̃XgɊi[
    mMemoList(m_MemoIndex) = GetDisplayMemo()

    'f[^t@Cۑ
    Call SaveFile
End Sub

'**
' V쐬
Public Function CreateNewMemo() As Boolean
    'Ɉꌏǉ
    ReDim Preserve mMemoList(Me.MemoCount + 1)
    Call cmbMemoList.AddItem("")
    Me.MemoIndex = Me.MemoCount

    CreateNewMemo = True
End Function

'**
' ANeBu폜
Public Function DeleteActiveMemo() As Boolean
    Dim MemoIndex As Long
    Dim Cancel As Boolean
    
    MemoIndex = Me.MemoIndex
    Cancel = False
    RaiseEvent BeforeDelete(MemoIndex, Cancel)
    If Not Cancel Then
        Call DeleteMemo(MemoIndex)
    End If
End Function

'**
' 폜
Public Sub DeleteMemo(ByVal MemoIndex As Long)
    Dim prevMemoIndex As Long
    prevMemoIndex = Me.MemoIndex
    
    '͈͊O͖
    If MemoIndex < 1 Or MemoIndex > Me.MemoCount Then
        Exit Sub
    End If
    
    'ANeBu폜悤ƂƂ́AxIԂɂ
    If MemoIndex = m_MemoIndex Then
        m_MemoIndex = -1
    End If
    
    '^Cg폜
    Call cmbMemoList.RemoveItem(MemoIndex - 1)
    
    '폜Ńf[^ȂȂĂ܂ꍇ́AVKꌏďI
    If Me.MemoCount = 1 Then
        ReDim mMemoList(0)
        Call CreateNewMemo
        Exit Sub
    End If

    'f[^폜
    Dim i As Long
    For i = MemoIndex To Me.MemoCount - 1
        mMemoList(i) = mMemoList(i + 1)
    Next i
    ReDim Preserve mMemoList(Me.MemoCount - 1)

    'ANeBu̓eXV
    Me.MemoIndex = prevMemoIndex
End Sub

'**
' ÕɈړ
Public Function MovePrevMemo() As Boolean
    MovePrevMemo = (Me.MemoIndex > 1)
    If MovePrevMemo Then
        Me.MemoIndex = Me.MemoIndex - 1
    End If
End Function

'**
' ̃Ɉړ
Public Function MoveNextMemo() As Boolean
    MoveNextMemo = (Me.MemoIndex < Me.MemoCount)
    If MoveNextMemo Then
        Me.MemoIndex = Me.MemoIndex + 1
    End If
End Function

'**
' ^Cghbv_E
Public Function DropdownTitle() As Boolean
    Call cmbMemoList.SetFocus
    Call SendMessage(cmbMemoList.hWnd, CB_SHOWDROPDOWN, API_TRUE, 0)
    DropdownTitle = True
End Function

'**
' ̌ݍssĂ݂
Public Function ExecuteMemoLine() As Boolean
    Dim lines() As String
    Dim pos As Long
    Dim line As Long
    Dim NewSelStart As Long
    Dim execStr As String
    
    'J[\̂s擾
    lines = Split(txtMemo.Text, vbCrLf)
    pos = txtMemo.SelStart
    For line = LBound(lines) To UBound(lines)
        pos = pos - Len(lines(line))
        pos = pos - 2 's
        If pos < 0 Then
            Exit For
        Else
            NewSelStart = NewSelStart + Len(lines(line)) + 2
        End If
    Next line
    
    'sĂ݂
    execStr = LTrim$(lines(line))
    ExecuteMemoLine = ExecuteFile(execStr)
    If ExecuteMemoLine Then
        '܂炻̍sI
        With txtMemo
            .SelStart = NewSelStart + (Len(lines(line)) - Len(execStr))
            .SelLength = Len(lines(line)) - (Len(lines(line)) - Len(execStr))
        End With
        RaiseEvent AfterExecuteFile
    End If
End Function


'********************************************************************************
'* JȂ\bh
'********************************************************************************
'**
' gpłt@Cǂ`FbN
Private Function CheckFileName(ByVal FileName As String) As Boolean
    Dim FolderName As String
    
    'tH_o
    FolderName = Left$(FileName, InStrRev("\" & FileName, "\") - 1)
    
    'tH_(JgfBNg)ȂOK
    If FolderName = "" Then
        CheckFileName = True
    
    'tH_݂OK
    ElseIf Dir$(FolderName, vbDirectory) <> "" Then
        CheckFileName = True
        
    'łȂNG
    Else
        CheckFileName = False
    End If
End Function

'**
' t@C烁ǂݍ݃Xg쐬
Private Sub LoadFile()
    Dim FileNo As Integer
    Dim buf() As Byte
    Dim bufs() As String
    Dim i As Long
    
    If m_FileName = "" Then
        Call Err.Raise(53)
    End If

    On Error GoTo ErrorHandler
    FileNo = FreeFile()
    ReDim buf(FileLen(m_FileName) - 1)
    Open FileName For Binary As #FileNo
    Get #FileNo, , buf
    Close #FileNo
    
    bufs = Split(StrConv(buf, vbUnicode), mc_SECTION_SEPARATOR)
    ReDim mMemoList(UBound(bufs) + 1)
    For i = LBound(bufs) To UBound(bufs)
        mMemoList(i + 1) = ParseMemo(bufs(i))
    Next i
Exit Sub

ErrorHandler:
    Select Case Err.Number
     Case 0
     Case 53 't@CȂ
        ReDim mMemoList(0)
     Case Else
        On Error GoTo 0
        Resume
    End Select
End Sub

'**
' Xgt@Cɕۑ
Private Sub SaveFile()
    Dim FileNo As Integer
    Dim buf As String
    Dim bufs() As String
    Dim i As Long

    ReDim bufs(UBound(mMemoList) - 1)
    For i = 1 To UBound(mMemoList)
        bufs(i - 1) = toStringMemo(mMemoList(i))
    Next i
    buf = Join$(bufs, mc_SECTION_SEPARATOR)

    On Error Resume Next
    Call Kill(m_FileName)
    On Error GoTo 0

    On Error GoTo ErrorHandler
    FileNo = FreeFile()
    Open FileName For Binary As #FileNo
    Put #FileNo, , buf
    Close #FileNo
Exit Sub

ErrorHandler:
    Select Case Err.Number
     Case 0
     Case Else
        On Error GoTo 0
        Resume
    End Select
End Sub

'**
' ꌏ̃p[X
Private Function ParseMemo(ByVal MemoData As String) As typeMemo
    Dim bufs() As String
    Dim Headers() As String
    Dim i As Long
    
    '".."݂̂̍s"."ɕϊ
    MemoData = Replace$(vbCrLf & MemoData & vbCrLf, vbCrLf & ".." & vbCrLf, vbCrLf & "." & vbCrLf)
    MemoData = Mid$(MemoData, 3, Len(MemoData) - 4)
    
    'wb_ƃ{fBɕ
    bufs = Split(MemoData, vbCrLf & vbCrLf, 2)
    
    '{fB擾
    If UBound(bufs) = 1 Then
        ParseMemo.Body = bufs(1)
    Else
        'wb_ƃ{fBɕłȂבSĂ{ɂďI
        ParseMemo = ParseMemoAllBody(MemoData)
        Exit Function
    End If
    
    'wb_
    Headers = Split(bufs(0), vbCrLf)
    For i = LBound(Headers) To UBound(Headers)
        bufs = Split(Headers(i), ":", 2)
        If UBound(bufs) = 1 Then
            Select Case bufs(0)
             Case "Title": ParseMemo.Title = bufs(1)
             Case "Last-Modified": ParseMemo.LastModified = bufs(1)
             Case "CursorPos":
                If IsNumeric(bufs(1)) Then
                    ParseMemo.CursorPos = CLng(bufs(1))
                Else
                    ParseMemo.CursorPos = 0
                End If
             Case Else
                'mȂwb_oĂ̂ŁASĂBODY
                ParseMemo = ParseMemoAllBody(MemoData)
                Exit Function
            End Select
        Else
            'wb_̌`ɂȂĂȂ̂oĂ̂ŁASĂBody
            ParseMemo = ParseMemoAllBody(MemoData)
            Exit Function
        End If
    Next i
End Function

'**
' SĂ{ɂ
Private Function ParseMemoAllBody(ByVal MemoData As String) As typeMemo
    With ParseMemoAllBody
        .Body = MemoData
        .Title = CreateTitleByMemo(MemoData)
        .LastModified = ""
        .CursorPos = 0
    End With
End Function

'**
' p[Xꂽ𕶎ɕϊ
Private Function toStringMemo(ByRef Memo As typeMemo) As String
    '^Cg̏ꍇA{擾
    If Memo.Title = "" Then
        Memo.Title = CreateTitleByMemo(Memo.Body)
    End If
    
    toStringMemo = "Title:" & Memo.Title & vbCrLf _
                 & "Last-Modified:" & Memo.LastModified & vbCrLf _
                 & "CursorPos:" & CStr(Memo.CursorPos) & vbCrLf _
                 & vbCrLf _
                 & Memo.Body
    
    '"."݂̂̍s".."ɕϊ
    toStringMemo = Replace$(vbCrLf & toStringMemo & vbCrLf, vbCrLf & "." & vbCrLf, vbCrLf & ".." & vbCrLf)
    toStringMemo = Mid$(toStringMemo, 3, Len(toStringMemo) - 4)
End Function

'**
' {^Cg
Private Function CreateTitleByMemo(ByVal MemoBody As String) As String
    Dim lines() As String
    Dim i As Long
    
    'sƂɕ
    lines = Split(MemoBody, vbCrLf)

    'ŏ͍̓s^CgƂ
    CreateTitleByMemo = ""
    For i = LBound(lines) To UBound(lines)
        If lines(i) <> "" Then
            CreateTitleByMemo = lines(i)
            Exit For
        End If
    Next i
End Function

'**
' w肳ꂽʂɕ\
Private Sub ShowMemo(ByVal MemoIndex As Long)
    Dim Memo As typeMemo
    
    Memo = mMemoList(MemoIndex)
    txtMemo.Text = Memo.Body
    txtMemo.SelStart = Memo.CursorPos
    cmbMemoList.Text = Memo.Title
    cmbMemoList.List(MemoIndex - 1) = Memo.Title
    cmbMemoList.ListIndex = MemoIndex - 1
    cmbMemoList.SelStart = 0
    cmbMemoList.SelLength = 0
    
    ' JE^[̕\XV
    lblCounter.Caption = CStr(Me.MemoIndex) & "/" & CStr(Me.MemoCount)
    
    '{^̏ԂύX
    cmdPrev.Enabled = (MemoIndex > 1)
    cmdNext.Enabled = (MemoIndex < Me.MemoCount)
End Sub

'**
' ʂ̓e^Ɋi[
Private Function GetDisplayMemo() As typeMemo
    With GetDisplayMemo
        .Body = txtMemo.Text
        If m_MemoIndex = cmbMemoList.ListIndex + 1 Then
            .Title = cmbMemoList.Text
            If .Title = "" Then
                .Title = CreateTitleByMemo(.Body)
            End If
        Else
            .Title = cmbMemoList.List(m_MemoIndex - 1)
        End If
        .LastModified = Format$(Now(), Me.DateFormat)
        .CursorPos = txtMemo.SelStart
    End With
End Function

'**
' wb_ǉBigpEEE[j
' @param Memo ǉΏۂ̃
' @param MemoString ǉ郁bZ[W
' @param LastModified ŏIXV
Private Sub AddMemo_Header(ByRef Memo As typeMemo, ByVal MemoString As String, ByVal LastModified As String)
    Dim CursorPos As Long

    'ǉ镶𐶐
    CursorPos = 0
    MemoString = ParseHeader(LastModified, CursorPos) _
               & ParseBody(MemoString, CursorPos)
    
    Select Case Me.HeaderAddPosition
     Case apHead
        Memo.CursorPos = CursorPos
        Memo.Body = MemoString & Memo.Body

     Case apTail
        Memo.CursorPos = Len(Memo.Body) + CursorPos
        Memo.Body = Memo.Body & MemoString
    End Select
End Sub

'**
' wb_ȂǉBigpEEE[j
' @param Memo ǉΏۂ̃
' @param MemoString ǉ郁bZ[W
' @param LastModified ŏIXV
Private Sub AddMemo_Body(ByRef Memo As typeMemo, ByVal MemoString As String, ByVal LastModified As String)
    Dim CursorPos As Long

    'ǉ镶𐶐
    CursorPos = 0
    MemoString = ParseBody(MemoString, CursorPos)
    
    Select Case Me.BodyAddPosition
     Case apHead
        If Me.HeaderFormat = "" Then
            '擪sɒǉ
            Memo.CursorPos = CursorPos
            Memo.Body = MemoString & Memo.Body

        ElseIf Me.HeaderAddPosition = apHead Then
            '擪̃wb_s̎̍sɒǉ
        
        ElseIf Me.HeaderAddPosition = apTail Then
            'Ō̃wb_s̎̍sɒǉ
            
        End If
    
     Case apTail
        If Me.HeaderFormat = "" Then
            'ŏIsɒǉ
            Memo.CursorPos = Len(Memo.Body) + CursorPos
            Memo.Body = Memo.Body & MemoString

        ElseIf Me.HeaderAddPosition = apHead Then
            'Ԗڂ̃wb_s̎Oɒǉ
        
        ElseIf Me.HeaderAddPosition = apTail Then
            'ŏIsɒǉ
            
        End If
    End Select
End Sub

'**
' wb_tH[}bg͂
Private Function ParseHeader(ByVal LastModified As String, ByRef CursorPos As Long) As String
    ParseHeader = Me.HeaderFormat
    ParseHeader = Replace$(ParseHeader, "$DATE", LastModified)
    ParseHeader = Replace$(ParseHeader, "\t", vbTab)
    ParseHeader = Replace$(ParseHeader, "\n", vbCrLf)
    
    'J[\ʒuԂ
    CursorPos = CursorPos + Len(ParseHeader)
End Function

'**
' tH[}bg͂
Private Function ParseBody(ByVal MemoString As String, ByRef CursorPos As Long) As String
    ParseBody = Me.BodyFormat
    ParseBody = Replace$(ParseBody, "$MEMO", MemoString)
    ParseBody = Replace$(ParseBody, "\t", vbTab)
    ParseBody = Replace$(ParseBody, "\n", vbCrLf)
    
    'J[\ʒuT
    Dim pos As Long
    pos = InStr(ParseBody, "$CURSOR")
    If pos >= 0 Then
        ParseBody = Replace$(ParseBody, "$CURSOR", "")
        CursorPos = CursorPos + pos - 1
    Else
        CursorPos = CursorPos + Len(ParseBody)
    End If
End Function



'********************************************************************************
'* CxgvV[W
'********************************************************************************

'--------------------------------------------------------------------------------
' E
'--------------------------------------------------------------------------------
Private Sub UserControl_Initialize()
    'Xg̏
    ReDim mMemoList(0)
    m_MemoIndex = 0
End Sub

Private Sub UserControl_Terminate()
    Erase mMemoList
End Sub

'--------------------------------------------------------------------------------
' ݃Cxg̈ϔC
'--------------------------------------------------------------------------------
Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

'--------------------------------------------------------------------------------
' vpeB̓ǂݍ݁Aۑ
'--------------------------------------------------------------------------------
Private Sub UserControl_InitProperties()
    Me.HeaderFormat = mc_DEFAULT_HEADERFORMAT
    Me.BodyFormat = mc_DEFAULT_BODYFORMAT
    Me.DateFormat = mc_DEFAULT_DATEFORMAT
    Me.HeaderAddPosition = mc_DEFAULT_HEADERADDPOSITION
    Me.BodyAddPosition = mc_DEFAULT_BODYADDPOSITION
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    With PropBag
        Me.HeaderFormat = .ReadProperty("HeaderFormat", mc_DEFAULT_HEADERFORMAT)
        Me.BodyFormat = .ReadProperty("BodyFormat", mc_DEFAULT_BODYFORMAT)
        Me.DateFormat = .ReadProperty("DateFormat", mc_DEFAULT_DATEFORMAT)
        Me.HeaderAddPosition = .ReadProperty("HeaderAddPosition", mc_DEFAULT_HEADERADDPOSITION)
        Me.BodyAddPosition = .ReadProperty("BodyAddPosition", mc_DEFAULT_BODYADDPOSITION)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        Call .WriteProperty("HeaderFormat", Me.HeaderFormat, mc_DEFAULT_HEADERFORMAT)
        Call .WriteProperty("BodyFormat", Me.BodyFormat, mc_DEFAULT_BODYFORMAT)
        Call .WriteProperty("DateFormat", Me.DateFormat, mc_DEFAULT_DATEFORMAT)
        Call .WriteProperty("HeaderAddPosition", Me.HeaderAddPosition, mc_DEFAULT_HEADERADDPOSITION)
        Call .WriteProperty("BodyAddPosition", Me.BodyAddPosition, mc_DEFAULT_BODYADDPOSITION)
    End With
End Sub

'--------------------------------------------------------------------------------
' UI
'--------------------------------------------------------------------------------
Private Sub cmdNew_Click()
    Call CreateNewMemo
End Sub

Private Sub cmdDelete_Click()
    Call DeleteActiveMemo
End Sub

Private Sub cmdPrev_Click()
    Call MovePrevMemo
End Sub

Private Sub cmdNext_Click()
    Call MoveNextMemo
End Sub

Private Sub cmbMemoList_Click()
    Me.MemoIndex = cmbMemoList.ListIndex + 1
End Sub

Private Sub cmbMemoList_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyReturn Then
        If SendMessage(cmbMemoList.hWnd, CB_GETDROPPEDSTATE, 0, 0) = API_FALSE Then
            Call txtMemo.SetFocus
        End If
    End If
End Sub

Private Sub cmbMemoList_KeyUp(KeyCode As Integer, Shift As Integer)
    Dim buf As String
    Dim SelStart As Integer, SelLength As Integer
    If m_IsChangedMemoTitle Then
        With cmbMemoList
            SelStart = .SelStart
            SelLength = .SelLength
            buf = .Text
            .List(m_MemoIndex - 1) = buf
            .Text = buf
            If SendMessage(cmbMemoList.hWnd, CB_GETDROPPEDSTATE, 0, 0) <> API_FALSE Then
                cmbMemoList.ListIndex = Me.MemoIndex - 1
            End If
            .SelStart = SelStart
            .SelLength = SelLength
        End With
        m_IsChangedMemoTitle = False
    End If
End Sub

Private Sub cmbMemoList_Change()
    m_IsChangedMemoTitle = True
End Sub

Private Sub txtMemo_DblClick()
    Call ExecuteMemoLine
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    
'    Call txtMemo.Move(0, 0, UserControl.Width, UserControl.Height - picBar.Height)
'    Call picBar.Move(0, txtMemo.Height)
'    Call cmbMemoList.Move(picBar.Width, txtMemo.Height, UserControl.Width - (picBar.Width + picCounter.Width))
'    Call picCounter.Move(cmbMemoList.Left + cmbMemoList.Width, txtMemo.Height)

    '^Cg
    Call picBar.Move(0, 0)
    Call cmbMemoList.Move(picBar.Width, 0, UserControl.Width - (picBar.Width + picCounter.Width))
    Call picCounter.Move(cmbMemoList.Left + cmbMemoList.Width, 0)
    Call txtMemo.Move(0, picBar.Height, UserControl.Width, UserControl.Height - picBar.Height)
End Sub
