VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CKeyMapping"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'****************************************************************************************************
'      : NX()
' @\Tv : L[{[h}bsOsȂNXB
'            CIniFile.clsƕp鎖ŁAJX^}CY@\񋟁B
' 쐬   : 2003/05/18
' XV : 2003/06/14 INIt@Cݒǂݍ݁Aۑ\ɂ
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile :
'****************************************************************************************************


'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function GetKeyboardState Lib "user32" (pbKeyState As Byte) As Long
'--------------------------------------------------------------
'**************************************************************



'====================================================================================================
' vCx[gȕϐE萔E\
'====================================================================================================
Private mFunctionNames As Collection
Private mKeyMappings As Collection
Private mObject As Object



'====================================================================================================
' JCxg
'====================================================================================================
Public Event BeforeExec(KeyCode As Integer, Shift As Integer)
Public Event AfterExec(KeyCode As Integer, Shift As Integer)
Public Event NotExist(KeyCode As Integer, Shift As Integer)



'====================================================================================================
' JvpeB
'====================================================================================================



'====================================================================================================
' J郁\bh
'====================================================================================================
Public Sub Initialize(ByRef ExecObject As Object _
                    , Optional ByRef ini As CIniFile = Nothing)
'----------------------------------------------------
' @\Tv : 
'      : ExecObject: sΏۃIuWFNg
'          : Ini       : INIIuWFNg(ȗ\)
' ߂l   : Ȃ
'----------------------------------------------------
    Set mObject = ExecObject
    
    If Not ini Is Nothing Then
        'INIIuWFNgw肳Ă猻݂SectionΏۂKeyMappingǂݍ
        Dim FunctionName As Variant
        Dim KeyMappings() As String
        Dim i As Long
        For Each FunctionName In ini.Keys
            KeyMappings = Split(ini.Data(FunctionName), ",")
            For i = LBound(KeyMappings) To UBound(KeyMappings)
                Call Me.Add(FunctionName, KeyMappings(i))
            Next i
        Next FunctionName
    End If
End Sub

Public Sub SaveMapping(ByRef ini As CIniFile)
'----------------------------------------------------
' @\Tv : ݃}bsOĂf[^INIt@Cɕۑ
'          : CIniFileIuWFNǧ݂̃ZNVɕۑ
'      : Ini       : INIIuWFNg
' ߂l   : Ȃ
'----------------------------------------------------
    Dim KeyMapping As Variant
    
    Call ini.Clear
    For Each KeyMapping In mKeyMappings
        If ini.Data(mFunctionNames(KeyMapping)) <> "" Then
            ini.Data(mFunctionNames(KeyMapping)) = ini.Data(mFunctionNames(KeyMapping)) & "," & KeyMapping
        Else
            ini.Data(mFunctionNames(KeyMapping)) = KeyMapping
        End If
    Next KeyMapping
    
    Call ini.Save(ini.NowSection)
End Sub

Public Sub Add(ByVal FunctionName As String, ByVal KeyMapping As String)
'----------------------------------------------------
' @\Tv : }bsOf[^ǉ
'      : FunctionName: s֐(֐TrueԂt@NVɂ邱)
'          : KeyMapping  : }bsOL[
' ߂l   : Ȃ
'----------------------------------------------------
    On Error Resume Next
    
    Call mKeyMappings.Add(KeyMapping, KeyMapping)
    If Err.Number <> 0 Then Exit Sub

    Call mFunctionNames.Add(FunctionName, KeyMapping)
    If Err.Number <> 0 Then
        Call mKeyMappings.Remove(KeyMapping)
    End If
End Sub

Public Sub AddDefault(ByVal FunctionName As String, ParamArray KeyMappings() As Variant)
'----------------------------------------------------
' @\Tv : }bsOf[^ǉ
'          : (pB܂FunctionNameo^ĂȂꍇ̂ݒǉ)
'      : FunctionName: s֐(֐TrueԂt@NVɂ邱)
'          : KeyMappings : }bsOL[̃Xg
' ߂l   : Ȃ
'----------------------------------------------------
    Dim KeyMapping As Variant
    
    'ɓo^ĂΏ𔲂
    If IsMappingFunction(FunctionName) Then Exit Sub
    
    For Each KeyMapping In KeyMappings
        Call Add(FunctionName, KeyMapping)
    Next KeyMapping
End Sub

Public Sub Exec(KeyCode As Integer, Shift As Integer)
'----------------------------------------------------
' @\Tv : }bsOꂽes
'      : KeyCode: L[R[h
'          : Shift  : }XNL[
' ߂l   : Ȃ
'----------------------------------------------------
    Dim FunctionName As String
    
    RaiseEvent BeforeExec(KeyCode, Shift)
    
    On Error GoTo ErrorHandler
    '֐T
    FunctionName = mFunctionNames(GetKeyCodeToKeyMapping(KeyCode, Shift))
    
    's
    If CallByName(mObject, FunctionName, VbMethod) Then
        KeyCode = 0
    End If
    
    On Error GoTo 0
    
    RaiseEvent AfterExec(KeyCode, Shift)
Exit Sub

ErrorHandler:
    Select Case Err.Number
     Case 0
     Case Else
        RaiseEvent NotExist(KeyCode, Shift)
    End Select
End Sub

Public Function GetFunctionName(ByVal KeyMapping As String) As String
'----------------------------------------------------
' @\Tv : t@NV擾
'      : KeyMapping : }bsOꂽL[
' ߂l   : t@NV
'----------------------------------------------------
    On Error Resume Next
    GetFunctionName = mFunctionNames(KeyMapping)
End Function

Public Function GetKeyMapping(ByVal FunctionName As String) As String
'----------------------------------------------------
' @\Tv : }bsOL[擾
'      : FunctionName : t@NV
' ߂l   : }bsOL[
'----------------------------------------------------
    Dim i As Long
    
    For i = 1 To mFunctionNames.Count
        If mFunctionNames(i) = FunctionName Then
            GetKeyMapping = mKeyMappings(i)
            Exit Function
        End If
    Next i
    
    GetKeyMapping = ""
End Function

Public Function IsKeyMapping(ByVal KeyCode As Integer, ByVal Shift As Integer) As Boolean
'----------------------------------------------------
' @\Tv : }bsOĂ邩`FbN
'      : KeyCode: L[R[h
'          : Shift  : }XNL[
' ߂l   : }bsOĂTrue
'----------------------------------------------------
    Dim KeyMapping As String
    
    On Error Resume Next
    KeyMapping = mKeyMappings(GetKeyCodeToKeyMapping(KeyCode, Shift))
    IsKeyMapping = (Err.Number = 0)
End Function

Public Function IsKeyMappingAscii(ByVal KeyAscii As Integer) As Boolean
'----------------------------------------------------
' @\Tv : }bsOĂ邩`FbN(AsciiR[h)
'      : KeyAscii: AsciiR[h
' ߂l   : }bsOĂTrue
'----------------------------------------------------
    Dim KeyCode As Integer
    Dim Shift As Integer

    Select Case KeyAscii
     Case Asc("A") To Asc("Z")
        KeyCode = vbKeyA + (KeyAscii - Asc("A"))
        Shift = IIf(CheckCapsLock(), 0, vbShiftMask)

     Case Asc("a") To Asc("z")
        KeyCode = vbKeyA + (KeyAscii - Asc("a"))
        Shift = IIf(CheckCapsLock(), vbShiftMask, 0)
    
     Case 1 To 24 'Ctrl+A to Ctrl+Z
        KeyCode = vbKeyA + (KeyAscii - 1)
        Shift = vbCtrlMask
        
    End Select
    
    IsKeyMappingAscii = IsKeyMapping(KeyCode, Shift)
End Function

Public Function IsMappingFunction(ByVal FunctionName As String) As Boolean
'----------------------------------------------------
' @\Tv : }bsOĂ邩`FbN(t@NVt)
'      : FunctionName : t@NV
' ߂l   : }bsOĂTrue
'----------------------------------------------------
    IsMappingFunction = (GetKeyMapping(FunctionName) <> "")
End Function



'====================================================================================================
' JȂ\bh
'====================================================================================================
Private Function GetKeyCodeToKeyMapping(ByVal KeyCode As Integer, ByVal Shift As Integer) As String
'----------------------------------------------------
' @\Tv : }bsOL[ɕϊ
'      : KeyCode: L[R[h
'          : Shift  : }XNL[
' ߂l   : }bsOL[
'----------------------------------------------------
    GetKeyCodeToKeyMapping = ""

    If (Shift And vbCtrlMask) = vbCtrlMask Then
        GetKeyCodeToKeyMapping = GetKeyCodeToKeyMapping & "Ctrl+"
    End If
    If (Shift And vbShiftMask) = vbShiftMask Then
        GetKeyCodeToKeyMapping = GetKeyCodeToKeyMapping & "Shift+"
    End If
    If (Shift And vbAltMask) = vbAltMask Then
        GetKeyCodeToKeyMapping = GetKeyCodeToKeyMapping & "Alt+"
    End If
    
    Dim KeyName As String
    Select Case KeyCode
     Case vbKeyA To vbKeyZ, vbKey0 To vbKey9, 64    '64:"@"
        KeyName = Chr(KeyCode)
     Case vbKeyNumpad0 To vbKeyNumpad9
        KeyName = "Num" & CStr(KeyCode - vbKeyNumpad0)
     Case vbKeyF1 To 135 '135:F24
        KeyName = "F" & CStr(KeyCode - vbKeyF1 + 1)
     Case vbKeyTab: KeyName = "Tab"
     Case vbKeyHome: KeyName = "Home"
     Case vbKeyEnd: KeyName = "End"
     Case vbKeySpace: KeyName = "Space"
     Case vbKeyBack: KeyName = "BackSpace"
     Case vbKeyReturn: KeyName = "Enter"
     Case vbKeyInsert: KeyName = "Insert"
     Case vbKeyDelete: KeyName = "Delete"
     Case vbKeyUp: KeyName = "Up"
     Case vbKeyDown: KeyName = "Down"
     Case vbKeyRight: KeyName = "Right"
     Case vbKeyLeft: KeyName = "Left"
     Case vbKeyPageUp: KeyName = "PageUp"
     Case vbKeyPageDown: KeyName = "PageDown"
     Case vbKeyEscape: KeyName = "Esc"
    End Select
    GetKeyCodeToKeyMapping = GetKeyCodeToKeyMapping & KeyName
End Function

Private Function CheckCapsLock() As Boolean
'----------------------------------------------------
' @\Tv : CapsbNĂ邩ׂ
'      : Ȃ
' ߂l   : bNĂTrue
'----------------------------------------------------
    Dim buf() As Byte
    
    buf = Space$(256)
    Call GetKeyboardState(buf(0))
    
    CheckCapsLock = (buf(vbKeyCapital) And 1&) = 1&
End Function



'====================================================================================================
' CxgvV[W
'====================================================================================================
Private Sub Class_Initialize()
    Set mKeyMappings = New Collection
    Set mFunctionNames = New Collection
End Sub

Private Sub Class_Terminate()
    Set mKeyMappings = Nothing
    Set mFunctionNames = Nothing
    Set mObject = Nothing
End Sub
