VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CLimitForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'================================================================================
'  : CLimitForm
'T  v: EBhẼTCY}NX
'쐬: 2000/03/
'쐬: <mailto:momotaro@yabumi.com>
'X  V: 2001/11/ LimitForm\bh̎dlύX
'      : 2001/11/21 MinWidth, MaxWidth, MinHeight, MaxHeightvpeBǉ
'      : 2001/11/21 Initialize\bhǉ
'      : 2001/11/21 LimitForm\bh폜
'  l: PʂvbPixels
'================================================================================
Option Explicit

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByVal Source As Any, ByVal Length As Long)
'--------------------------------------------------------------
Private Type POINTAPI
        X As Long
        Y As Long
End Type
Private Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type
'--------------------------------------------------------------
Private Const WM_GETMINMAXINFO As Long = &H24&
'**************************************************************


'********************************************************************************
'* ϐ`
'********************************************************************************
Private mSaveMinMax As MINMAXINFO

Private m_hWnd As Long
Public PreWndProcAddress As Long



'********************************************************************************
'* vpeB`
'********************************************************************************

Public Property Get hWnd() As Long
'================================================================================
': ǎp
'Tv: EBhEnh
'l: mdlSubClassŎgp
'================================================================================
    hWnd = m_hWnd
End Property

Public Property Get MaxWidth() As Long
'================================================================================
': Ǐp
'Tv: ̍ől
'================================================================================
    MaxWidth = mSaveMinMax.ptMaxTrackSize.X
End Property
Public Property Let MaxWidth(ByVal NewMaxWidth As Long)
    If NewMaxWidth > 0 Then
        mSaveMinMax.ptMaxTrackSize.X = NewMaxWidth
    Else
        mSaveMinMax.ptMaxTrackSize.X = Screen.Width \ Screen.TwipsPerPixelX
    End If
End Property

Public Property Get MaxHeight() As Long
'================================================================================
': Ǐp
'Tv: ̍ől
'================================================================================
    MaxHeight = mSaveMinMax.ptMaxTrackSize.Y
End Property
Public Property Let MaxHeight(ByVal NewMaxHeight As Long)
    If NewMaxHeight > 0 Then
        mSaveMinMax.ptMaxTrackSize.Y = NewMaxHeight
    Else
        mSaveMinMax.ptMaxTrackSize.Y = Screen.Height \ Screen.TwipsPerPixelY
    End If
End Property

Public Property Get MinWidth() As Long
'================================================================================
': Ǐp
'Tv: ̍ŏl
'================================================================================
    MinWidth = mSaveMinMax.ptMinTrackSize.X
End Property
Public Property Let MinWidth(ByVal NewMinWidth As Long)
    If NewMinWidth > 0 Then
        mSaveMinMax.ptMinTrackSize.X = NewMinWidth
    Else
        mSaveMinMax.ptMinTrackSize.X = 0
    End If
End Property

Public Property Get MinHeight() As Long
'================================================================================
': Ǐp
'Tv: ̍ŏl
'================================================================================
    MinHeight = mSaveMinMax.ptMinTrackSize.Y
End Property
Public Property Let MinHeight(ByVal NewMinHeight As Long)
    If NewMinHeight > 0 Then
        mSaveMinMax.ptMinTrackSize.Y = NewMinHeight
    Else
        mSaveMinMax.ptMinTrackSize.Y = 0
    End If
End Property


'********************************************************************************
'* \bh`
'********************************************************************************

Public Function Initialize(ByVal hWnd As Long) As Boolean
'================================================================================
'Tv: 
': hWnd: Ώۂ̃EBhEnh
'ߒl: True
'================================================================================
    If m_hWnd <> hWnd Then
        m_hWnd = hWnd
        Call StartSubClass_(Me)
        Initialize = True
    End If
End Function



'********************************************************************************
'* EBhEvV[W
'********************************************************************************

Public Function WindowProc(ByVal hWnd As Long, ByVal iMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    WindowProc = API_TRUE
    
    If iMsg = WM_GETMINMAXINFO Then
        Dim MinMax As MINMAXINFO
        Call MoveMemory(ByVal VarPtr(MinMax), ByVal lParam, LenB(MinMax))
        MinMax.ptMaxTrackSize = mSaveMinMax.ptMaxTrackSize
        MinMax.ptMinTrackSize = mSaveMinMax.ptMinTrackSize
        Call MoveMemory(ByVal lParam&, ByVal VarPtr(MinMax), LenB(MinMax))
        WindowProc = API_FALSE
    End If
End Function



'********************************************************************************
'* CxgvV[W
'********************************************************************************

Private Sub Class_Initialize()
    With mSaveMinMax.ptMaxTrackSize
        .X = Screen.Width \ Screen.TwipsPerPixelX
        .Y = Screen.Height \ Screen.TwipsPerPixelY
    End With
    With mSaveMinMax.ptMinTrackSize
        .X = 0
        .Y = 0
    End With
End Sub

Private Sub Class_Terminate()
    Call EndSubClass_(Me)
End Sub

