Attribute VB_Name = "mdlComDlg"
Option Explicit
'****************************************************************************************************
'      : WW[()
' @\Tv : R_CAO\֐Q
' 쐬   : 2000/05/
' XV : 2001/04/20 wb_Rgt
'            2002/08/27 ShowOpenFolder쐬
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile : Ȃ
'****************************************************************************************************

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function SHBrowseForFolder Lib "shell32.dll" (ByRef lpbi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath As String) As Long
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal pv As Long)
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'--------------------------------------------------------------
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustomFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    Flags As EnumOFN
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type
Private Type BROWSEINFO
    hwndOwner As Long
    pidlRoot As EnumCSIDL
    pszDisplayName As String
    lpszTitle As String
    ulFlags As EnumBIF
    lpfn As Long
    lParam As Long
    iImage As Long
End Type
'--------------------------------------------------------------
Public Enum EnumOFN
    OFN_ALLOWMULTISELECT = &H200
    OFN_CREATEPROMPT = &H2000
    OFN_ENABLEHOOK = &H20
    OFN_ENABLESIZING = &H800000
    OFN_ENABLETEMPLATE = &H40
    OFN_ENABLETEMPLATEHANDLE = &H80
    OFN_EXPLORER = &H80000                         '  new look commdlg
    OFN_EXTENSIONDIFFERENT = &H400
    OFN_FILEMUSTEXIST = &H1000
    OFN_HIDEREADONLY = &H4
    OFN_LONGNAMES = &H200000                       '  force long names for 3.x modules
    OFN_NOCHANGEDIR = &H8
    OFN_NODEREFERENCELINKS = &H100000
    OFN_NOLONGNAMES = &H40000                      '  force no long names for 4.x modules
    OFN_NONETWORKBUTTON = &H20000
    OFN_NOREADONLYRETURN = &H8000
    OFN_NOTESTFILECREATE = &H10000
    OFN_NOVALIDATE = &H100
    OFN_OVERWRITEPROMPT = &H2
    OFN_PATHMUSTEXIST = &H800
    OFN_READONLY = &H1
    OFN_SHAREAWARE = &H4000
    OFN_SHAREFALLTHROUGH = 2
End Enum
Public Enum EnumCSIDL
    CSIDL_DESKTOP = &H0
End Enum
Public Enum EnumBIF
    BIF_RETURNONLYFSDIRS = &H1          'Rg[plAv^Au[tP[X͑Is
    BIF_DONTGOBELOWDOMAIN = &H2         'lbg[NRs[^̃\[X\
    BIF_STATUSTEXT = &H4                'eLXg\iݒ̓R[obN֐ōsȂj
    BIF_RETURNFSANCESTORS = &H8         'lbg[NRs[^̃\[X̂ݑI
    BIF_EDITBOX = &H10                  'tH_ҏWeLXgBox\
    BIF_VALIDATE = &H20                 '??
    BIF_USENEWUI = &H40                 '??
    BIF_BROWSEFORCOMPUTER = &H1000      'lbg[NRs[^̃\[X̂ݑI
    BIF_BROWSEFORPRINTER = &H2000       'lbg[Nv^̂ݑI
    BIF_BROWSEINCLUDEFILES = &H4000     'tH_̃t@C\iWindows98ȍ~j
End Enum
Private Const MAX_PATH              As Long = 260
Private Const BFFM_INITIALIZED      As Long = 1
Private Const WM_USER               As Long = &H400
Private Const BFFM_SETSELECTIONA    As Long = (WM_USER + 102)
'**************************************************************

Public Function ShowSaveDialog(ByVal hWnd As Long _
                             , Optional ByVal Title As String = vbNullString _
                             , Optional ByVal DefaultPath As String = vbNullString _
                             , Optional ByVal DefaultFile As String = vbNullString _
                             , Optional ByVal Filter As String = vbNullString) As String
    Dim OFN As OPENFILENAME
    Dim rtn As Long
    
    With OFN
        .lStructSize = Len(OFN)
        .hwndOwner = hWnd
        .hInstance = 0
        .lpstrFilter = Filter
        .nMaxCustomFilter = 0&
        .nFilterIndex = 1
        .lpstrFile = DefaultFile & String$(256 - LenB(StrConv(DefaultFile, vbFromUnicode)), vbNullChar)
        .nMaxFile = 256
        .lpstrFileTitle = DefaultFile & String$(256 - LenB(StrConv(DefaultFile, vbFromUnicode)), vbNullChar)
        .nMaxFileTitle = 256
        .lpstrInitialDir = DefaultPath
        If Title = vbNullString Then Title = "̧قۑ"
        .lpstrTitle = Title
        .Flags = OFN_EXPLORER Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
        .lpstrDefExt = vbNullString
    End With

    rtn = GetSaveFileName(OFN)
    
    If rtn <> API_FALSE Then
        ShowSaveDialog = Left$(OFN.lpstrFile, InStr(OFN.lpstrFile & vbNullChar, vbNullChar) - 1)
    End If
End Function

Public Function ShowOpenDialog(ByVal hWnd As Long _
                             , Optional ByVal Title As String = vbNullString _
                             , Optional ByVal DefaultPath As String = vbNullString _
                             , Optional ByVal DefaultFile As String = vbNullString _
                             , Optional ByVal Filter As String = vbNullString) As String
    Dim OFN As OPENFILENAME
    Dim rtn As Long
    
    With OFN
        .lStructSize = Len(OFN)
        .hwndOwner = hWnd
        .hInstance = 0
        .lpstrFilter = Replace$(Filter, "|", vbNullChar)
        .nMaxCustomFilter = 0&
        .nFilterIndex = 1
        .lpstrFile = DefaultFile & String$(256 - LenB(StrConv(DefaultFile, vbFromUnicode)), vbNullChar)
        .nMaxFile = 256
        .lpstrFileTitle = DefaultFile & String$(256 - LenB(StrConv(DefaultFile, vbFromUnicode)), vbNullChar)
        .nMaxFileTitle = 256
        .lpstrInitialDir = DefaultPath
        If Title = vbNullString Then Title = "̧قJ"
        .lpstrTitle = Title
        .Flags = OFN_EXPLORER Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
        .lpstrDefExt = vbNullString
    End With

    rtn = GetOpenFileName(OFN)
    
    If rtn <> API_FALSE Then
        ShowOpenDialog = Left$(OFN.lpstrFile, InStr(OFN.lpstrFile & vbNullChar, vbNullChar) - 1)
    End If
End Function

Public Function ShowOpenDialogMulti(ByVal hWnd As Long _
                                  , Optional ByVal Title As String = vbNullString _
                                  , Optional ByVal DefaultPath As String = vbNullString _
                                  , Optional ByVal DefaultFile As String = vbNullString _
                                  , Optional ByVal Filter As String = vbNullString) As String()
    Dim OFN As OPENFILENAME
    Dim bufs() As String
    Dim rtn As Long
    Dim i As Long
    
    With OFN
        .lStructSize = Len(OFN)
        .hwndOwner = hWnd
        .hInstance = 0
        .lpstrFilter = Replace$(Filter, "|", vbNullChar)
        .nMaxCustomFilter = 0&
        .nFilterIndex = 1
        .lpstrFile = DefaultFile & String$(100000 - LenB(StrConv(DefaultFile, vbFromUnicode)), vbNullChar)
        .nMaxFile = 100000
        .lpstrFileTitle = DefaultFile & String$(256 - LenB(StrConv(DefaultFile, vbFromUnicode)), vbNullChar)
        .nMaxFileTitle = 256
        .lpstrInitialDir = DefaultPath
        If Title = vbNullString Then Title = "̧قJ"
        .lpstrTitle = Title
        .Flags = OFN_EXPLORER Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST Or OFN_ALLOWMULTISELECT
        .lpstrDefExt = vbNullString
    End With

    rtn = GetOpenFileName(OFN)
    
    If rtn = API_FALSE Then
        ShowOpenDialogMulti = Split("")
    Else
        OFN.lpstrFile = Left$(OFN.lpstrFile, InStr(OFN.lpstrFile & String$(2, vbNullChar), String$(2, vbNullChar)) - 1)
        bufs = Split(OFN.lpstrFile, vbNullChar)
        
        If UBound(bufs) > 0 Then
            OFN.lpstrFile = bufs(0) & IIf(Right$(bufs(0), 1) = "\", "", "\")
            For i = 1 To UBound(bufs)
                bufs(i - 1) = OFN.lpstrFile & bufs(i)
            Next i
            ReDim Preserve bufs(UBound(bufs) - 1) As String
        End If
        
        ShowOpenDialogMulti = bufs
    End If
End Function

Public Function ShowOpenFolder(ByVal hWnd As Long _
                             , Optional ByVal Title As String = "tH_IĂ" _
                             , Optional ByVal Flags As EnumBIF = BIF_RETURNONLYFSDIRS _
                             , Optional ByVal RootPath As EnumCSIDL = CSIDL_DESKTOP _
                             , Optional ByVal DefaultPath As String = vbNullChar) As String
    Dim BI As BROWSEINFO
    Dim pID As Long
    
    With BI
        .hwndOwner = hWnd
        .pidlRoot = RootPath
        .pszDisplayName = Title
        .ulFlags = Flags
        .lpfn = FARPROC(AddressOf BrowseCallbackProc)
        DefaultPath = StrConv(DefaultPath, vbFromUnicode) & IIf(Right$(DefaultPath, 1) = vbNullChar, "", vbNullChar)
        .lParam = StrPtr(DefaultPath)
    End With
    pID = SHBrowseForFolder(BI)
    
    If pID Then
        ShowOpenFolder = String$(MAX_PATH, vbNullChar)
        Call SHGetPathFromIDList(pID, ShowOpenFolder)
        Call CoTaskMemFree(pID)
        ShowOpenFolder = Left$(ShowOpenFolder, InStr(ShowOpenFolder & vbNullChar, vbNullChar) - 1)
    End If
End Function

Private Function FARPROC(ByVal pfn As Long) As Long
    FARPROC = pfn
End Function

Public Function BrowseCallbackProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal lParam As Long, ByVal lpData As Long) As Long
    If uMsg = BFFM_INITIALIZED Then
        Call SendMessage(hWnd, BFFM_SETSELECTIONA, 1, lpData)
    End If
End Function
