Attribute VB_Name = "mdlControl"
Option Explicit
'****************************************************************************************************
'      : WW[()
' @\Tv : Rg[𑀍삷ׂ̊֐Q
' 쐬   : 2000/05/
' XV : 2001/04/20 wb_Rgt
' 쐬   :  <momotaro@yabumi.com>
'----------------------------------------------------------------------------------------------------
' ˑFile : ./App.bas
'****************************************************************************************************

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function MoveWindow Lib "user32" (ByVal hWnd As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SHAutoComplete Lib "Shlwapi.dll" (ByVal hwndEdit As Long, ByVal dwFlags As EnumSHAutoComplete) As Long
Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
'--------------------------------------------------------------
Public Enum EnumSHAutoComplete
    SHACF_DEFAULT = &H0
    SHACF_FILESYSTEM = &H1
    SHACF_URLHISTORY = &H2
    SHACF_URLMRU = &H4
    SHACF_URLALL = (SHACF_URLHISTORY Or SHACF_URLMRU)
    SHACF_USETAB = &H8
    SHACF_AUTOSUGGEST_FORCE_ON = &H10000000
    SHACF_AUTOSUGGEST_FORCE_OFF = &H20000000
    SHACF_AUTOAPPEND_FORCE_ON = &H40000000
    SHACF_AUTOAPPEND_FORCE_OFF = &H80000000
End Enum
'--------------------------------------------------------------
Private Const GW_CHILD = 5
Private Const CB_SETDROPPEDWIDTH As Long = &H160
'**************************************************************

' === eLXg{bNX̓e𔽓] ===
Public Sub SelectTextBox(ByRef TextBox As Control)
    Select Case TypeName(TextBox)
     Case "TextBox", "ComboBox"
        With TextBox
            .SelStart = 0
            .SelLength = Len(.Text)
        End With
    End Select
End Sub

' === R{{bNX̍ύX ===
'ftHgƂ߂ςɍL
Public Sub SetComboBoxHeight(ByRef ComboBox As Control _
                           , Optional ByVal MaxItemCount As Long = 0 _
                           , Optional ByVal MaxWidth As Long = 0)
    Dim H As Long
    Dim W As Long
    Dim i As Long
    
    With ComboBox
        'ύX
        H = .ListCount
        If MaxItemCount > 0 And H > MaxItemCount Then H = MaxItemCount
        H = .Parent.TextHeight("W") * (H + 1) + (.Height + 2)
        Call MoveWindow(.hWnd, _
                        .Left / Screen.TwipsPerPixelX, _
                        .Top / Screen.TwipsPerPixelY, _
                        .Width / Screen.TwipsPerPixelX, _
                        H / Screen.TwipsPerPixelY, _
                        API_TRUE)
        
        'ύX
        For i = 0 To .ListCount - 1
            If W < .Parent.TextWidth(.List(i)) Then
                W = .Parent.TextWidth(.List(i))
            End If
        Next i
        If MaxItemCount > 0 And W > MaxWidth Then W = MaxWidth
        If W < .Width Then
            W = .Width / Screen.TwipsPerPixelY
        Else
            W = W / Screen.TwipsPerPixelY + 5
        End If
        Call SendMessage(.hWnd, CB_SETDROPPEDWIDTH, W, 0&)
    End With
End Sub

' === I[gRv[g𗘗p ===
Public Function AutoComplete(ByRef TextBox As Control, ByVal flags As EnumSHAutoComplete) As Boolean
    Dim hWnd As Long
    Dim rtn As Long
    
    If IsExistAPI("Shlwapi.dll", "SHAutoComplete") Then
        If TypeName(TextBox) = "TextBox" Then
            hWnd = TextBox.hWnd
        ElseIf TypeName(TextBox) = "ComboBox" Then
            hWnd = GetCombo2Text(TextBox.hWnd)
        Else
            Exit Function
        End If
        rtn = SHAutoComplete(hWnd, flags)
        AutoComplete = (rtn <> API_FALSE)
    End If
End Function

' === R{{bNX̃eLXg̃nh擾 ===
Private Function GetCombo2Text(ByVal CombohWnd As Long) As Long
    GetCombo2Text = GetWindow(CombohWnd, GW_CHILD)
End Function
