VERSION 5.00
Begin VB.UserControl uHotKey 
   BackStyle       =   0  '
   ClientHeight    =   345
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3090
   ScaleHeight     =   345
   ScaleWidth      =   3090
   Begin VB.TextBox txtCode 
      Height          =   315
      Left            =   0
      Locked          =   -1  'True
      TabIndex        =   0
      Top             =   0
      Width           =   3015
   End
End
Attribute VB_Name = "uHotKey"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'*** API֐` **********************************************
Private Const API_TRUE  As Long = &HFFFFFFFF
Private Const API_FALSE As Long = &H0
'--------------------------------------------------------------
Private Declare Function GetKeyState _
 Lib "user32" _
    (ByVal nVirtKey As Long) As Long
'--------------------------------------------------------------
Private Enum EnumHoekeyModifier
    MOD_ALT = &H1
    MOD_CONTROL = &H2
    MOD_SHIFT = &H4
    MOD_WIN = &H8
End Enum
'--------------------------------------------------------------
Private Const VK_LWIN As Long = &H5B
Private Const VK_RWIN As Long = &H5C
'**************************************************************

Private m_HotKey As Long
Private m_HotKeyMask As Long

Public Event Change()

Public Property Get Text() As String
Attribute Text.VB_Description = "\ĂeLXgԂ܂B"
Attribute Text.VB_UserMemId = -517
Attribute Text.VB_MemberFlags = "200"
    Text = txtCode.Text
End Property

Public Property Get HotKey() As Long
Attribute HotKey.VB_Description = "zbgL[̐ݒ܂Bl̎擾\łB"
    HotKey = m_HotKey
End Property
Public Property Let HotKey(ByVal NewHotKey As Long)
    Dim buf As String
    buf = CheckKey(NewHotKey)
    If buf <> "" Then
        Call ChangeText(CheckMask(m_HotKeyMask) & buf)
    Else
        Call ChangeText("")
    End If
    Call UserControl.PropertyChanged("HotKey")
End Property

Public Property Get Mask() As Long
Attribute Mask.VB_Description = "}XNL[ݒ肵܂Bl̎擾\łB"
    Mask = m_HotKeyMask
End Property
Public Property Let Mask(ByVal NewMask As Long)
    Dim buf As String
    buf = CheckMask(NewMask)
    If buf <> "" Then
        Call ChangeText(buf & CheckKey(m_HotKey))
    Else
        Call ChangeText("")
    End If
    Call UserControl.PropertyChanged("Mask")
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "հް̑ŔĂA޼ުĂɔF邩ǂݒ肵܂Bl̎擾\łB"
Attribute Enabled.VB_UserMemId = -514
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewEnabled As Boolean)
    UserControl.Enabled = NewEnabled
    txtCode.Enabled = NewEnabled
    Call UserControl.PropertyChanged("Enabled")
End Property

Private Sub txtCode_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim strCodeName As String
    Dim buf As String
    Dim Mask As EnumHoekeyModifier

    m_HotKeyMask = 0
    m_HotKey = 0

    '[Ctrl], [Shift], [Alt]L[Ă邩`FbN
    If (Shift And vbCtrlMask) = vbCtrlMask Then
        Mask = Mask Or MOD_CONTROL
    End If
    If (Shift And vbShiftMask) = vbShiftMask Then
        Mask = Mask Or MOD_SHIFT
    End If
    If (Shift And vbAltMask) = vbAltMask Then
        Mask = Mask Or MOD_ALT
    End If
    '[Windows]L[Ă邩`FbN
    If (GetKeyState(VK_LWIN) And &H80) = &H80 Or (GetKeyState(VK_RWIN) And &H80) = &H80 Then
        Mask = Mask Or MOD_WIN
    End If

    '}XNL[̃`FbN
    strCodeName = CheckMask(Mask)

    'ʏL[̃`FbN
    buf = CheckKey(KeyCode)
    If buf <> "" Then
        strCodeName = strCodeName & buf
    End If

    'ʂ̔f
    Call ChangeText(strCodeName)

    KeyCode = 0
End Sub

Private Sub txtCode_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
     Case vbKeyTab
        '
     Case vbKeyDelete, vbKeyBack
        Call ChangeText("")
     Case Else
        KeyAscii = 0
    End Select
End Sub

Private Sub txtCode_KeyUp(KeyCode As Integer, Shift As Integer)
    If m_HotKey = 0 Then Call ChangeText("")
End Sub

Private Sub ChangeText(ByVal strText As String)
    With txtCode
        If strText = "" Then strText = "(Ȃ)"
        .Text = strText
        .SelStart = Len(.Text)
    End With
    RaiseEvent Change
End Sub

'// }XNL[̏Ԃ`FbN
Private Function CheckMask(ByVal Mask As EnumHoekeyModifier) As String
    If (Mask And MOD_CONTROL) = MOD_CONTROL Then
        CheckMask = CheckMask + "Ctrl + "
    End If
    If (Mask And MOD_SHIFT) = MOD_SHIFT Then
        CheckMask = CheckMask + "Shift + "
    End If
    If (Mask And MOD_ALT) = MOD_ALT Then
        CheckMask = CheckMask + "Alt + "
    End If
    If (Mask And MOD_WIN) = MOD_WIN Then
        CheckMask = CheckMask + "Windows + "
    End If
    m_HotKeyMask = Mask
'    Select Case Mask
'    ' [Ctrl] + [Alt]
'     Case (MOD_CONTROL Or MOD_ALT)
'        CheckMask = "Ctrl + Alt + "
'        m_HotKeyMask = Mask
'
'    ' [Ctrl] + [Shift] + [Alt]
'     Case (MOD_CONTROL Or MOD_SHIFT Or MOD_ALT)
'        CheckMask = "Ctrl + Shift + Alt + "
'        m_HotKeyMask = Mask
'
'    ' [Windows]
'     Case MOD_WIN
'        CheckMask = "Windows + "
'        m_HotKeyMask = Mask
'
'    End Select
End Function

'// ʏL[̏Ԃ`FbN
Private Function CheckKey(ByVal KeyCode As Long) As String
    Select Case KeyCode
     Case 48 To 57      '0 ` 9
        CheckKey = CStr(KeyCode - 48)
        m_HotKey = KeyCode

     Case 65 To 90      'A ` Z
        CheckKey = Chr$(KeyCode)
        m_HotKey = KeyCode

     Case 96 To 105     'Num0 ` Num9
        CheckKey = "Num" & CStr(KeyCode - 96)
        m_HotKey = KeyCode

     Case 112 To 135    'F1 ` F24
        CheckKey = "F" & CStr(KeyCode - 111)
        m_HotKey = KeyCode

     Case 37 To 40      ',,,
        CheckKey = Mid$("", KeyCode - 36, 1)
        m_HotKey = KeyCode

     Case Else
        CheckKey = ""

    End Select
End Function

Private Sub UserControl_Resize()
    txtCode.Move 0, 0, UserControl.ScaleWidth, UserControl.ScaleHeight
End Sub

Private Sub UserControl_InitProperties()
    m_HotKey = 0
    m_HotKeyMask = 0
    Call ChangeText("")
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Me.Enabled = PropBag.ReadProperty("Enabled", True)
    Me.HotKey = PropBag.ReadProperty("HotKey", 0)
    Me.Mask = PropBag.ReadProperty("Mask", 0)
    Call ChangeText("")
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("Enabled", Me.Enabled, True)
    Call PropBag.WriteProperty("HotKey", Me.HotKey, 0)
    Call PropBag.WriteProperty("Mask", Me.Mask, 0)
    Call PropBag.WriteProperty("Text", Me.Text, "(Ȃ)")
End Sub
